'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = fetchFunctions;
/**
 * Created by kakoyi on 2017-03-20.
 */

function parseFunction(src) {
    var e = /s\d+"([a-zA-Z_]+)"/ig;
    var root = [{}];
    for (var r = e.exec(src); r; r = e.exec(src)) {
        var list = r[1].split('_');
        var func = list.pop();
        var last = root;
        for (var i in list) {
            var name = list[i];
            name = name.charAt(0).toLowerCase() + name.substr(1);
            if (!last[0][name]) {
                last[0][name] = [{}];
            }
            last = last[0][name];
        }
        last.push(func.charAt(0).toLowerCase() + func.substr(1));
    }
    return root;
}

function fetchFunctions(src, config) {
    if (!src) {
        src = config.url.replace(/^ws/, 'http');
    }
    var dst = src;
    if (/^[a-zA-Z][a-z-A-Z\d]+:\/\//i.test(src)) {
        dst = fetch(src).then(function (rep) {
            return rep.text();
        }).then(function (rep) {
            return parseFunction(rep);
        });
    }
    if (!(dst instanceof Promise)) {
        dst = Promise.resolve(dst);
    }
    return dst;
}